QwtPlotPicker(3)

NAME
QwtPlotPicker -

QwtPlotPicker provides selections on a plot canvas.

SYNOPSIS

#include <qwt_plot_picker.h>

Inherits QwtPicker.

Inherited by QwtPlotZoomer.

  Signals

void selected (const QwtDoublePoint &pos)
void selected (const QwtDoubleRect &rect)
void selected (const QwtArray< QwtDoublePoint > &pa)
void appended (const QwtDoublePoint &pos)
void moved (const QwtDoublePoint &pos)

  Public Member Functions

QwtPlotPicker (QwtPlotCanvas *)
virtual ~QwtPlotPicker ()
QwtPlotPicker (int xAxis, int yAxis, QwtPlotCanvas *)
QwtPlotPicker (int xAxis, int yAxis, int selectionFlags, RubberBand rubberBand, DisplayMode trackerMode, QwtPlotCanvas *)
virtual void setAxis (int xAxis, int yAxis)
int xAxis () const
int yAxis () const
QwtPlot * plot ()
const QwtPlot * plot () const
QwtPlotCanvas * canvas ()
const QwtPlotCanvas * canvas () const

  Protected Member Functions

QwtDoubleRect scaleRect () const
QwtDoubleRect invTransform (const QRect &) const
QRect transform (const QwtDoubleRect &) const
QwtDoublePoint invTransform (const QPoint &) const
QPoint transform (const QwtDoublePoint &) const
virtual QwtText trackerText (const QPoint &) const
virtual QwtText trackerText (const QwtDoublePoint &) const
virtual void move (const QPoint &)
virtual void append (const QPoint &)
virtual bool end (bool ok=true)

Detailed Description

QwtPlotPicker provides selections on a plot canvas.

QwtPlotPicker is a QwtPicker tailored for selections on a plot canvas. It is set to a x-Axis and y-Axis and translates all pixel coordinates into this coodinate system.

Constructor & Destructor Documentation

  QwtPlotPicker::QwtPlotPicker (QwtPlotCanvas * canvas) [explicit]

Create a plot picker. The picker is set to those x- and y-axis of the plot that are enabled. If both or no x-axis are enabled, the picker is set to QwtPlot::xBottom. If both or no y-axis are enabled, it is set to QwtPlot::yLeft.

Parameters:
    canvas Plot canvas to observe, also the parent object

See also:
    QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::scaleRect()

  QwtPlotPicker::~QwtPlotPicker () [virtual]

Destructor.

  QwtPlotPicker::QwtPlotPicker (int xAxis, int yAxis, QwtPlotCanvas * canvas) [explicit] Create a plot picker

Parameters:
    xAxis Set the x axis of the picker
    yAxis Set the y axis of the picker
    canvas Plot canvas to observe, also the parent object

See also:
    QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::scaleRect()

  QwtPlotPicker::QwtPlotPicker (int xAxis, int yAxis, int selectionFlags, RubberBand rubberBand, DisplayMode trackerMode, QwtPlotCanvas * canvas) [explicit] Create a plot picker

Parameters:
    xAxis X axis of the picker
    yAxis Y axis of the picker
    selectionFlags Or'd value of SelectionType, RectSelectionType and SelectionMode
    rubberBand Rubberband style
    trackerMode Tracker mode
    canvas Plot canvas to observe, also the parent object

See also:
    QwtPicker, QwtPicker::setSelectionFlags(), QwtPicker::setRubberBand(), QwtPicker::setTrackerMode

    QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::scaleRect()

Member Function Documentation

  void QwtPlotPicker::append (const QPoint & pos) [protected, virtual] Append a point to the selection and update rubberband and tracker.

Parameters:
    pos Additional point

See also:
    isActive, begin(), end(), move(), appended()

Note:
    The appended(const QPoint &), appended(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

  void QwtPlotPicker::appended (const QwtDoublePoint & pos) [signal] A signal emitted when a point has been appended to the selection

Parameters:
    pos Position of the appended point.

See also:
    append(). moved()

  const QwtPlotCanvas * QwtPlotPicker::canvas () const

Return Observed plot canvas.

  QwtPlotCanvas * QwtPlotPicker::canvas ()

Return observed plot canvas.

  bool QwtPlotPicker::end (bool ok = true) [protected, virtual] Close a selection setting the state to inactive.

Parameters:
    ok If true, complete the selection and emit selected signals otherwise discard the selection.

Returns:
    true if the selection is accepted, false otherwise

Reimplemented from QwtPicker.

Reimplemented in QwtPlotZoomer.

  QwtDoublePoint QwtPlotPicker::invTransform (const QPoint & pos) const [protected] Translate a point from pixel into plot coordinates

Returns:
    Point in plot coordinates

See also:
    QwtPlotPicker::transform()

  QwtDoubleRect QwtPlotPicker::invTransform (const QRect & rect) const [protected] Translate a rectangle from pixel into plot coordinates

Returns:
    Rectangle in plot coordinates

See also:
    QwtPlotPicker::transform()

  void QwtPlotPicker::move (const QPoint & pos) [protected, virtual] Move the last point of the selection

Parameters:
    pos New position

See also:
    isActive, begin(), end(), append()

Note:
    The moved(const QPoint &), moved(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

  void QwtPlotPicker::moved (const QwtDoublePoint & pos) [signal] A signal emitted whenever the last appended point of the selection has been moved.

Parameters:
    pos Position of the moved last point of the selection.

See also:
    move(), appended()

  const QwtPlot * QwtPlotPicker::plot () const

Return plot widget, containing the observed plot canvas.

  QwtPlot * QwtPlotPicker::plot ()

Return plot widget, containing the observed plot canvas.

  QwtDoubleRect QwtPlotPicker::scaleRect () const [protected] Return normalized bounding rect of the axes

See also:
    QwtPlot::autoReplot(), QwtPlot::replot().

  void QwtPlotPicker::selected (const QwtArray< QwtDoublePoint > & pa) [signal] A signal emitting the selected points, at the end of a selection.

Parameters:
    pa Selected points

  void QwtPlotPicker::selected (const QwtDoubleRect & rect) [signal] A signal emitted in case of selectionFlags() & RectSelection.

Parameters:
    rect Selected rectangle

  void QwtPlotPicker::selected (const QwtDoublePoint & pos) [signal] A signal emitted in case of selectionFlags() & PointSelection.

Parameters:
    pos Selected point

  void QwtPlotPicker::setAxis (int xAxis, int yAxis) [virtual] Set the x and y axes of the picker

Parameters:
    xAxis X axis
    yAxis Y axis

Reimplemented in QwtPlotZoomer.

  QwtText QwtPlotPicker::trackerText (const QwtDoublePoint & pos) const [protected, virtual]

Translate a position into a position string. In case of HLineRubberBand the label is the value of the y position, in case of VLineRubberBand the value of the x position. Otherwise the label contains x and y position separated by a ',' .

The format for the double to string conversion is '%.4f'.

Parameters:
    pos Position

Returns:
    Position string

  QwtText QwtPlotPicker::trackerText (const QPoint & pos) const [protected, virtual] Translate a pixel position into a position string

Parameters:
    pos Position in pixel coordinates

Returns:
    Position string

Reimplemented from QwtPicker.

  QPoint QwtPlotPicker::transform (const QwtDoublePoint & pos) const [protected] Translate a point from plot into pixel coordinates

Returns:
    Point in pixel coordinates

See also:
    QwtPlotPicker::invTransform()

  QRect QwtPlotPicker::transform (const QwtDoubleRect & rect) const [protected] Translate a rectangle from plot into pixel coordinates

Returns:
    Rectangle in pixel coordinates

See also:
    QwtPlotPicker::invTransform()

  int QwtPlotPicker::xAxis () const

Return x axis.

  int QwtPlotPicker::yAxis () const

Return y axis.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.